;============================RegmPlus.dll=============================
;Adds log file reopening for Regmon v4.32 with Drag and Drop support.
;Requires RegmPatch.exe. See attached tutorial.
;
;Written by Kayaker Mar/2001
;=====================================================================

.386
.model flat,stdcall
option casemap:none
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comdlg32.inc     ;need for GetOpenFileName
include \masm32\include\shell32.inc      ;need for DragQueryFileA
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\shell32.lib
;---------------------------------------------------------------------

.data
lpClassName db "RegmonClass",0           ;Main window Class name
lpszClass db "SysListView32",0           ;ListView control Class name

ofn OPENFILENAME <>                      ;declare GetOpenFileName structure
strFilter db "Log Files",0,"*.log",0
          db "All Files",0,"*.*",0,0
             
Num_Rows DWORD 0
;---------------------------------------------------------------------

.data?

hFileOpened HANDLE ?    ;handle to file returned from CreateFile
hMapFile HANDLE ?       ;handle of CreateFileMapping object
Map_Start DWORD ?       ;starting address of the mapped view
szFileOpened DWORD ?    ;length of file from GetFileSize
hMainWindow HANDLE ?    ;hWnd of Main window returned from FindWindow
hListView HANDLE ?      ;hWnd of SysListview32 control from FindWindowEx
strFile db 512 dup(?)
String_Start DWORD ?
;-----------------------------------------------------------------------

.code
DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov  eax,TRUE
	ret
DllEntry Endp

;===============OpenLog Function===============
OpenLog proc

    pushad

    ; --------------------------------------------------------------------------
    ; If file was dragged and dropped get its name
    ; --------------------------------------------------------------------------

    mov ebx,40DB68h      ;address we stored [EBP-10] = wParam of WM_DROPFILES in
    mov eax,[ebx]	 ;address of internal drop structure for WM_DROPFILES
                
    .if eax!=0     	 ;if it contains a valid address get the filename
    
        invoke DragQueryFileA,eax,0,ADDR strFile,(SIZEOF strFile)-1 
            mov dword ptr [ebx],0	   ;zero address pointer for next time                
            jmp Open_File

    .elseif		 ;if user used the menu to open file
    
    ; --------------------------------------------------------------------------
    ; Initialize OPENFILENAME structure associated with GetOpenFileName function
    ; --------------------------------------------------------------------------
    
        mov ofn.lStructSize,SIZEOF ofn
        mov ofn.lpstrFilter, OFFSET strFilter
        mov ofn.lpstrFile, OFFSET strFile
        mov ofn.nMaxFile, (SIZEOF strFile)-1

    ; --------------------------------------------------------------------------
    ; 'Open' Common Dialog box procedure
    ; --------------------------------------------------------------------------
    
        invoke GetOpenFileName, ADDR ofn
        
    .endif
   
    .if eax==TRUE 	;if user selected a file
               
Open_File:  nop

        invoke CreateFile,ADDR strFile,GENERIC_READ+GENERIC_WRITE,\
                FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_ARCHIVE,NULL
            mov hFileOpened,eax
                    
    ; --------------------------------------------------------------------------
    ; Map file into memory with write access (PAGE_WRITECOPY), but don't allow
    ; changes to be written back to original file (FILE_MAP_COPY)
    ; --------------------------------------------------------------------------

        invoke CreateFileMapping, hFileOpened,NULL,PAGE_WRITECOPY,0,0,NULL
            mov hMapFile,eax
        invoke MapViewOfFile, hMapFile,FILE_MAP_COPY,0,0,0
            mov Map_Start,eax
        invoke IsBadCodePtr,Map_Start	;just to check if memory address readable
        				;helps in tracing/debugging as well because
        				;it causes memory mapped file to display
        				        
        .if (!eax)    			;if OK

    ; --------------------------------------------------------------------------
    ; Get file size
    ; --------------------------------------------------------------------------

            invoke GetFileSize,hFileOpened,NULL
                mov szFileOpened,eax

    ; --------------------------------------------------------------------------
    ; Call main routine
    ; --------------------------------------------------------------------------

            Call Populate_ListView

    ; --------------------------------------------------------------------------
    ; Clear all memory usage
    ; --------------------------------------------------------------------------
        
        .endif
                
            invoke UnmapViewOfFile, Map_Start	;unmap mapped view of file
            invoke CloseHandle, hMapFile	;close file mapping object handle
            invoke CloseHandle, hFileOpened	;close file handle

    .endif
popad
ret
OpenLog endp
;===============End OpenLog Function===================


    ; ==========================================================================
    ; MAIN ROUTINE: 
    ; ==========================================================================
    
Populate_ListView proc

    ; --------------------------------------------------------------------------
    ; declare LOCAL directive for LV_ITEM structure; allocates memory from the stack.
    ; - in the form of <name of local variable>:<variable type>
    ; --------------------------------------------------------------------------
    
    LOCAL lvi:LV_ITEM

    ; --------------------------------------------------------------------------
    ; find hWnd of Main window and SysListView32 control, both of which will be
    ; used in SendMessage calls
    ; --------------------------------------------------------------------------

    invoke FindWindow,ADDR lpClassName,NULL
        mov hMainWindow,eax 		;store hWnd of Main window
    invoke FindWindowEx,hMainWindow,NULL,ADDR lpszClass,NULL
        mov hListView,eax 		;store hWnd of SysListView32 control

    ; --------------------------------------------------------------------------
    ; Send Capture Events and Clear Display message to Main window.
    ; Before opening a log we want to stop any Regmon monitoring and clear the
    ; display. Since the Capture Events button is normally toggled on/off by the
    ; user, we need to know in which state it is in beforehand, if already off
    ; we don't want to send the message. By tracing the Capture Events routine
    ; from the menu we previously found that a flag is set by Regmon in address
    ; [410270], 0 for OFF, 1 for ON.
    ;
    ; The values 09C52 and 09C54 specify the MenuItemID for Capture Events and
    ; Clear Display respectively, so we are essentially selecting these menu
    ; commands remotely.
    ; --------------------------------------------------------------------------

    mov eax,410270h
    mov al,byte ptr [eax]

    .if al==1 				;if flag is set toggle Capture Events OFF            
        invoke SendMessage,hMainWindow,WM_COMMAND,09C52h,NULL                
    .endif

    invoke SendMessage,hMainWindow,WM_COMMAND,09C54h,NULL 	;Clear Display

    ; --------------------------------------------------------------------------
    ; Convert "09" delimiters in file to NULL.
    ; A Regmon logfile has each column entry terminated by "09" and each row entry
    ; terminated by "0D0A".  By changing each "09" to "00" in memory, we create what
    ; is essentially one long Null-terminated string which we can work with easily.
    ;
    ; The following is a simple SCASB (SCAn Some Byte) routine which scans for
    ; and replaces with "00" each occurence of "09", incrementing a Num_Rows
    ; counter after the 7th column.
    ; --------------------------------------------------------------------------

            xor ebx,ebx
            cld 			;clear direction flag, process string left to right
            mov ecx, szFileOpened 	;length of file as a counter in ecx
            mov edi,Map_Start 		;start of file in memory, load source in edi
            mov al,09			;load byte to scan for in accumulator

null_09:    repne scasb 		;scan for 09's
            jnz null_fin 		;will exit when cx=0

            mov byte ptr [edi-1],NULL  ;when 09 found, edi will point to address
                                       ;immediately after, so we decrement by 1
            inc ebx
            cmp ebx,07 		       ;7 columns reached?
            jnz null_09

            inc Num_Rows 	       ;count the number of rows we have
            xor ebx,ebx                   
            jmp null_09

    ; --------------------------------------------------------------------------
    ; Initialize LV_ITEM structure that is used with the LVM_INSERTITEM and
    ; LVM_SETITEM messages
    ; 
    ; We need to deal with only 4 of the 9 fields in that structure
    ; 1) imask: LVIF_TEXT flag specifies that the pszText field contains valid data
    ; 2) iItem: 0-based index which can be thought of as "row" number
    ; 3) iSubItem: 1-based index which can be thought of as "column" number
    ; 4) pszText: address of ASCII string used with LVM_INSERTITEM and LVM_SETITEM
    ;
    ; In a ListView control, entries in the 1st column are considered "items" and every
    ; subsequent column are considered "subitems" of that item. So for our Regmon log,
    ; the 1st column entry in the 1st row is referenced as .iItem 0, iSubItem 0,
    ; the 2nd column entry in the 1st row is referenced as .iItem 0, iSubItem 1, etc.
    ;
    ; However, LVM_INSERTITEM can only be used with inserting Items and LVM_SETITEM
    ; can only be used with inserting SubItems.
    ;
    ; I can't really explain it any better than Iczelion in his excellent tutorial,
    ; so I quote:
    ;
    ; Let's summarize the steps in inserting an item/subitem into a listview control.
    ; 1) Create a variable of type LV_ITEM structure
    ; 2) Fill it with necessary information
    ; 3) Send LVM_INSERTITEM message to the listview control if you want to insert an
    ; item, or if you want to *insert* a subitem, send LVM_SETITEM instead. This is
    ; rather confusing if you don't understand the relationship between an item and its
    ; subitems. Subitems are considered as properties of an item. Thus you can insert
    ; items but not subitems and you can't have a subitem without an associated item.
    ; That's why you need to send LVM_SETITEM message to add a subitem instead of
    ; LVM_INSERTITEM.
    ; --------------------------------------------------------------------------

null_fin: mov lvi.imask,LVIF_TEXT           ;set imask flag
          mov lvi.iItem,0                   ;set to row 1
      
          push dword ptr [Map_Start]        ;push start address onto stack
          pop String_Start                  ;pop it into variable String_Start
          mov esi,dword ptr [Num_Rows]      ;numbers of rows we have

          .while lvi.iItem<esi              ;until the last row is reached

    ; --------------------------------------------------------------------------
    ; Insert 1st column item
    ; --------------------------------------------------------------------------
 
              mov lvi.iSubItem,0            ;set to column 1

              push String_Start             ;push address containing ASCII text onto stack
              pop lvi.pszText               ;pop it into pszText field

              invoke SendMessage,hListView,LVM_INSERTITEM,0,ADDR lvi

              invoke lstrlen,String_Start   ;get length of string
              inc eax                       ;add 1 for NULL terminator
              add String_Start,eax          ;set pointer to next string

    ; --------------------------------------------------------------------------
    ; Insert column subitems 2-7
    ; --------------------------------------------------------------------------

                .while lvi.iSubItem<06      
            
                    inc lvi.iSubItem

                    push String_Start
                    pop lvi.pszText

                    invoke SendMessage,hListView,LVM_SETITEM,0,ADDR lvi
                    
                    invoke lstrlen,String_Start
                    inc eax
                    add String_Start,eax
                .endw
    
            add String_Start,2              ;add 2 for "0D0A" LF/CR entries
            inc lvi.iItem                   ;increment to next row
          .endw
              

ret
Populate_ListView endp

;=======================================

    ; --------------------------------------------------------------------------
    ; Now go and start double clicking on the Regmon entries!
    ; --------------------------------------------------------------------------

End DllEntry
